
  .globl Nil
  .type Nil, @function

Nil:
  pushq %rbp
  movq %rsp, %rbp
  movl	$8, %edi
  call	malloc@PLT
  movq	$0, (%rax)
  movq %rbp, %rsp
  popq %rbp
  ret


  .globl Cons
  .type Cons, @function

Cons:
  pushq %rbp
  movq %rsp, %rbp
  movl	$24, %edi
  call	malloc@PLT
  movq	$1, (%rax)
  movq	24(%rbp), %rdx
  movq	%rdx, 8(%rax)
  movq	16(%rbp), %rdx
  movq	%rdx, 16(%rax)
  movq %rbp, %rsp
  popq %rbp
  ret


  .globl length
  .type length, @function

length:
  pushq %rbp
  movq %rsp, %rbp
  subq $0, %rsp
.Llength:
  movq 16(%rbp), %rax
  pushq %rax
  movq $0, %rax
  pushq %rax
  call lengthAcc
  addq $16, %rsp
  addq $0, %rsp
  movq %rbp, %rsp
  popq %rbp
  ret


  .globl lengthAcc
  .type lengthAcc, @function

lengthAcc:
  pushq %rbp
  movq %rsp, %rbp
  subq $8, %rsp
.LlengthAcc:
  movq 24(%rbp), %rax
  movq   (%rax), %rcx
  cmpq  $0, %rcx
  je  .L0
  cmpq  $1, %rcx
  je  .L1
  jmp  .L2
.L0:
  movq %rax, -8(%rbp)
  movq 16(%rbp), %rax
  jmp  .L2
.L1:
  movq %rax, -8(%rbp)
  movq -8(%rbp), %rax
  movq	16(%rax), %rax
  pushq %rax
  movq $1, %rax
  pushq %rax
  movq 16(%rbp), %rax
  popq %rbx
  addq %rbx, %rax
  pushq %rax
  popq %rax
  movq %rax, 16(%rbp)
  popq %rax
  movq %rax, 24(%rbp)
  jmp .LlengthAcc
  jmp  .L2
.L2:
  addq $8, %rsp
  movq %rbp, %rsp
  popq %rbp
  ret


  .globl sum
  .type sum, @function

sum:
  pushq %rbp
  movq %rsp, %rbp
  subq $0, %rsp
.Lsum:
  movq 16(%rbp), %rax
  pushq %rax
  movq $0, %rax
  pushq %rax
  call sumAcc
  addq $16, %rsp
  addq $0, %rsp
  movq %rbp, %rsp
  popq %rbp
  ret


  .globl sumAcc
  .type sumAcc, @function

sumAcc:
  pushq %rbp
  movq %rsp, %rbp
  subq $8, %rsp
.LsumAcc:
  movq 24(%rbp), %rax
  movq   (%rax), %rcx
  cmpq  $0, %rcx
  je  .L3
  cmpq  $1, %rcx
  je  .L4
  jmp  .L5
.L3:
  movq %rax, -8(%rbp)
  movq 16(%rbp), %rax
  jmp  .L5
.L4:
  movq %rax, -8(%rbp)
  movq -8(%rbp), %rax
  movq	16(%rax), %rax
  pushq %rax
  movq -8(%rbp), %rax
  movq	8(%rax), %rax
  pushq %rax
  movq 16(%rbp), %rax
  popq %rbx
  addq %rbx, %rax
  pushq %rax
  popq %rax
  movq %rax, 16(%rbp)
  popq %rax
  movq %rax, 24(%rbp)
  jmp .LsumAcc
  jmp  .L5
.L5:
  addq $8, %rsp
  movq %rbp, %rsp
  popq %rbp
  ret


  .globl reverse
  .type reverse, @function

reverse:
  pushq %rbp
  movq %rsp, %rbp
  subq $0, %rsp
.Lreverse:
  movq 16(%rbp), %rax
  pushq %rax
  call Nil
  addq $0, %rsp
  pushq %rax
  call reverseAux
  addq $16, %rsp
  addq $0, %rsp
  movq %rbp, %rsp
  popq %rbp
  ret


  .globl reverseAux
  .type reverseAux, @function

reverseAux:
  pushq %rbp
  movq %rsp, %rbp
  subq $8, %rsp
.LreverseAux:
  movq 24(%rbp), %rax
  movq   (%rax), %rcx
  cmpq  $0, %rcx
  je  .L6
  cmpq  $1, %rcx
  je  .L7
  jmp  .L8
.L6:
  movq %rax, -8(%rbp)
  movq 16(%rbp), %rax
  jmp  .L8
.L7:
  movq %rax, -8(%rbp)
  movq -8(%rbp), %rax
  movq	16(%rax), %rax
  pushq %rax
  movq -8(%rbp), %rax
  movq	8(%rax), %rax
  pushq %rax
  movq 16(%rbp), %rax
  pushq %rax
  call Cons
  addq $16, %rsp
  pushq %rax
  popq %rax
  movq %rax, 16(%rbp)
  popq %rax
  movq %rax, 24(%rbp)
  jmp .LreverseAux
  jmp  .L8
.L8:
  addq $8, %rsp
  movq %rbp, %rsp
  popq %rbp
  ret


  .globl append
  .type append, @function

append:
  pushq %rbp
  movq %rsp, %rbp
  subq $8, %rsp
.Lappend:
  movq 24(%rbp), %rax
  movq   (%rax), %rcx
  cmpq  $0, %rcx
  je  .L9
  cmpq  $1, %rcx
  je  .L10
  jmp  .L11
.L9:
  movq %rax, -8(%rbp)
  movq 16(%rbp), %rax
  jmp  .L11
.L10:
  movq %rax, -8(%rbp)
  movq -8(%rbp), %rax
  movq	8(%rax), %rax
  pushq %rax
  movq -8(%rbp), %rax
  movq	16(%rax), %rax
  pushq %rax
  movq 16(%rbp), %rax
  pushq %rax
  call append
  addq $16, %rsp
  pushq %rax
  call Cons
  addq $16, %rsp
  jmp  .L11
.L11:
  addq $8, %rsp
  movq %rbp, %rsp
  popq %rbp
  ret


  .globl add
  .type add, @function

add:
  pushq %rbp
  movq %rsp, %rbp
  subq $0, %rsp
.Ladd:
  movq 24(%rbp), %rax
  pushq %rax
  movq 16(%rbp), %rax
  pushq %rax
  call Nil
  addq $0, %rsp
  pushq %rax
  call Cons
  addq $16, %rsp
  pushq %rax
  call append
  addq $16, %rsp
  addq $0, %rsp
  movq %rbp, %rsp
  popq %rbp
  ret


  .globl take
  .type take, @function

take:
  pushq %rbp
  movq %rsp, %rbp
  subq $8, %rsp
.Ltake:
  movq 16(%rbp), %rax
  movq   (%rax), %rcx
  cmpq  $0, %rcx
  je  .L12
  cmpq  $1, %rcx
  je  .L13
  jmp  .L14
.L12:
  movq %rax, -8(%rbp)
  movq 16(%rbp), %rax
  jmp  .L14
.L13:
  movq %rax, -8(%rbp)
  movq 24(%rbp), %rax
  cmpq	$0, %rax
  je	.L16
  movq -8(%rbp), %rax
  movq	8(%rax), %rax
  pushq %rax
  movq $1, %rax
  pushq %rax
  movq 24(%rbp), %rax
  popq %rbx
  subq %rbx, %rax
  pushq %rax
  movq -8(%rbp), %rax
  movq	16(%rax), %rax
  pushq %rax
  call take
  addq $16, %rsp
  pushq %rax
  call Cons
  addq $16, %rsp
  jmp	.L15
.L16:
  call Nil
  addq $0, %rsp
.L15:
  jmp  .L14
.L14:
  addq $8, %rsp
  movq %rbp, %rsp
  popq %rbp
  ret


  .globl drop
  .type drop, @function

drop:
  pushq %rbp
  movq %rsp, %rbp
  subq $8, %rsp
.Ldrop:
  movq 24(%rbp), %rax
  cmpq	$0, %rax
  je	.L18
  movq 16(%rbp), %rax
  movq   (%rax), %rcx
  cmpq  $0, %rcx
  je  .L19
  cmpq  $1, %rcx
  je  .L20
  jmp  .L21
.L19:
  movq %rax, -8(%rbp)
  movq 16(%rbp), %rax
  jmp  .L21
.L20:
  movq %rax, -8(%rbp)
  movq 24(%rbp), %rax
  cmpq	$0, %rax
  je	.L23
  movq $1, %rax
  pushq %rax
  movq 24(%rbp), %rax
  popq %rbx
  subq %rbx, %rax
  pushq %rax
  movq -8(%rbp), %rax
  movq	16(%rax), %rax
  pushq %rax
  popq %rax
  movq %rax, 16(%rbp)
  popq %rax
  movq %rax, 24(%rbp)
  jmp .Ldrop
  jmp	.L22
.L23:
  movq 16(%rbp), %rax
.L22:
  jmp  .L21
.L21:
  jmp	.L17
.L18:
  movq 16(%rbp), %rax
.L17:
  addq $8, %rsp
  movq %rbp, %rsp
  popq %rbp
  ret


  .globl last
  .type last, @function

last:
  pushq %rbp
  movq %rsp, %rbp
  subq $24, %rsp
.Llast:
  movq 16(%rbp), %rax
  movq   (%rax), %rcx
  cmpq  $1, %rcx
  je  .L24
  cmpq  $0, %rcx
  je  .L25
  jmp  .L26
.L24:
  movq %rax, -16(%rbp)
  movq -16(%rbp), %rax
  movq	16(%rax), %rax
  movq   (%rax), %rcx
  cmpq  $0, %rcx
  je  .L27
  cmpq  $1, %rcx
  je  .L28
  jmp  .L29
.L27:
  movq %rax, -24(%rbp)
  movq -16(%rbp), %rax
  movq	8(%rax), %rax
  jmp  .L29
.L28:
  movq %rax, -8(%rbp)
  movq -8(%rbp), %rax
  pushq %rax
  popq %rax
  movq %rax, 16(%rbp)
  jmp .Llast
  jmp  .L29
.L29:
  jmp  .L26
.L25:
  movq %rax, -24(%rbp)
  movq $42, %rax
  jmp  .L26
.L26:
  addq $24, %rsp
  movq %rbp, %rsp
  popq %rbp
  ret


  .globl start
  .type start, @function

start:
  pushq %rbp
  movq %rsp, %rbp
  subq $0, %rsp
.Lstart:
  movq $1, %rax
  pushq %rax
  movq $2, %rax
  pushq %rax
  movq $4, %rax
  pushq %rax
  movq $2, %rax
  pushq %rax
  movq $1, %rax
  pushq %rax
  movq $2, %rax
  pushq %rax
  movq $3, %rax
  pushq %rax
  movq $4, %rax
  pushq %rax
  call Nil
  addq $0, %rsp
  pushq %rax
  call Cons
  addq $16, %rsp
  pushq %rax
  call Cons
  addq $16, %rsp
  pushq %rax
  call Cons
  addq $16, %rsp
  pushq %rax
  call Cons
  addq $16, %rsp
  pushq %rax
  call reverse
  addq $8, %rsp
  pushq %rax
  movq $1, %rax
  pushq %rax
  movq $2, %rax
  pushq %rax
  movq $3, %rax
  pushq %rax
  movq $4, %rax
  pushq %rax
  call Nil
  addq $0, %rsp
  pushq %rax
  call Cons
  addq $16, %rsp
  pushq %rax
  call Cons
  addq $16, %rsp
  pushq %rax
  call Cons
  addq $16, %rsp
  pushq %rax
  call Cons
  addq $16, %rsp
  pushq %rax
  call reverse
  addq $8, %rsp
  pushq %rax
  call append
  addq $16, %rsp
  pushq %rax
  call drop
  addq $16, %rsp
  pushq %rax
  call take
  addq $16, %rsp
  pushq %rax
  call sum
  addq $8, %rsp
  pushq %rax
  call Nil
  addq $0, %rsp
  pushq %rax
  call Cons
  addq $16, %rsp
  pushq %rax
  call Cons
  addq $16, %rsp
  pushq %rax
  call Cons
  addq $16, %rsp
  pushq %rax
  call last
  addq $8, %rsp
  addq $0, %rsp
  movq %rbp, %rsp
  popq %rbp
  ret


  .globl start2
  .type start2, @function

start2:
  pushq %rbp
  movq %rsp, %rbp
  subq $0, %rsp
.Lstart2:
  call Nil
  addq $0, %rsp
  pushq %rax
  call last
  addq $8, %rsp
  addq $0, %rsp
  movq %rbp, %rsp
  popq %rbp
  ret

